package com.example.bean.validation;

import java.io.IOException;
import java.io.PrintWriter;
import java.util.ServiceLoader;
import java.util.Set;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.ConstraintViolation;
import javax.validation.Path;
import javax.validation.Validation;
import javax.validation.Validator;
import javax.validation.ValidatorFactory;
import javax.validation.spi.ValidationProvider;

@WebServlet(name = "ValidationServlet", urlPatterns = {"/"})
public class ValidationServlet extends HttpServlet {

  @Override
  protected void doGet(HttpServletRequest request, HttpServletResponse response) throws IOException {
    response.setContentType("text/plain;charset=UTF-8");
    try (PrintWriter out = response.getWriter()) {
      try {
        for (ValidationProvider v : ServiceLoader.load(ValidationProvider.class)) {
          out.println("ValidationProvider: " + v.getClass());
        }

        SomeEntity x = new SomeEntity();
        x.setA("a");
        x.setB("ěšřěč");
        x.setC("ccccccccc");

        final SomeEntity y = new SomeEntity();
        y.setA("a");
        y.setB("********");
        x.setNestedEntity(y);

        for (int i = 0; i < 4; i++) {
          SomeEntity e = new SomeEntity();
          e.setA("aaa");
          e.setB("-*-*-*");
          x.getNestedEntities().add(e);
        }

        ValidatorFactory factory = Validation.buildDefaultValidatorFactory();
        Validator validator = factory.getValidator();
        Set<ConstraintViolation<SomeEntity>> violations = validator.validate(x);

        for (ConstraintViolation<SomeEntity> v : violations) {
          out.println("Error: " + v.getMessage());
          final Path cesta = v.getPropertyPath();
          out.println("Path: " + cesta);
          cesta.forEach(n -> {
            out.println("    " + n.getName() + " key=" + n.getKey() + " index=" + n.getIndex() + " kind=" + n.getKind() + " isInIterable=" + n.isInIterable());
          });
          out.println("--------");
        }
      } catch (Exception e) {
        e.printStackTrace(out);
      }
    }

  }
}
